"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.commandNames = exports.rcOptionsTypes = exports.cliOptionsTypes = void 0;
exports.help = help;
exports.handler = handler;
const path_1 = __importDefault(require("path"));
const cli_utils_1 = require("@pnpm/cli-utils");
const common_cli_options_help_1 = require("@pnpm/common-cli-options-help");
const write_project_manifest_1 = require("@pnpm/write-project-manifest");
const render_help_1 = __importDefault(require("render-help"));
const install = __importStar(require("./install"));
exports.cliOptionsTypes = install.cliOptionsTypes;
exports.rcOptionsTypes = install.rcOptionsTypes;
exports.commandNames = ['unlink', 'dislink'];
function help() {
    return (0, render_help_1.default)({
        aliases: ['dislink'],
        description: 'Removes the link created by `pnpm link` and reinstalls package if it is saved in `package.json`',
        descriptionLists: [
            {
                title: 'Options',
                list: [
                    {
                        description: 'Unlink in every package found in subdirectories \
or in every workspace package, when executed inside a workspace. \
For options that may be used with `-r`, see "pnpm help recursive"',
                        name: '--recursive',
                        shortAlias: '-r',
                    },
                    ...common_cli_options_help_1.UNIVERSAL_OPTIONS,
                ],
            },
        ],
        url: (0, cli_utils_1.docsUrl)('unlink'),
        usages: [
            'pnpm unlink (in package dir)',
            'pnpm unlink <pkg>...',
        ],
    });
}
async function handler(opts, params) {
    if (!opts.rootProjectManifest?.pnpm?.overrides)
        return 'Nothing to unlink';
    if (!params || (params.length === 0)) {
        for (const selector in opts.rootProjectManifest.pnpm.overrides) {
            if (opts.rootProjectManifest.pnpm.overrides[selector].startsWith('link:')) {
                delete opts.rootProjectManifest.pnpm.overrides[selector];
            }
        }
    }
    else {
        for (const selector in opts.rootProjectManifest.pnpm.overrides) {
            if (opts.rootProjectManifest.pnpm.overrides[selector].startsWith('link:') && params.includes(selector)) {
                delete opts.rootProjectManifest.pnpm.overrides[selector];
            }
        }
    }
    await (0, write_project_manifest_1.writeProjectManifest)(path_1.default.join(opts.rootProjectManifestDir, 'package.json'), opts.rootProjectManifest);
    await install.handler(opts);
    return undefined;
}
//# sourceMappingURL=unlink.js.map